HDU-4126(Genghis Khan the Conqueror)

Problem Description
Genghis Khan(成吉思汗)(1162-1227), also known by his birth name Temujin(铁木真) and temple name Taizu(元太祖), was the founder of the Mongol Empire and the greatest conqueror in Chinese history. After uniting many of the nomadic tribes on the Mongolian steppe, Genghis Khan founded a strong cavalry equipped by irony discipline, sabers and powder, and he became to the most fearsome conqueror in the history. He stretched the empire that resulted in the conquest of most of Eurasia. The following figure (origin: Wikipedia) shows the territory of Mongol Empire at that time.
在这里插入图片描述
Our story is about Jebei Noyan(哲别), who was one of the most famous generals in Genghis Khan’s cavalry. Once his led the advance troop to invade a country named Pushtuar. The knights rolled up all the cities in Pushtuar rapidly. As Jebei Noyan’s advance troop did not have enough soldiers, the conquest was temporary and vulnerable and he was waiting for the Genghis Khan’s reinforce. At the meantime, Jebei Noyan needed to set up many guarders on the road of the country in order to guarantee that his troop in each city can send and receive messages safely and promptly through those roads.

There were N cities in Pushtuar and there were bidirectional roads connecting cities. If Jebei set up guarders on a road, it was totally safe to deliver messages between the two cities connected by the road. However setting up guarders on different road took different cost based on the distance, road condition and the residual armed power nearby. Jebei had known the cost of setting up guarders on each road. He wanted to guarantee that each two cities can safely deliver messages either directly or indirectly and the total cost was minimal.

Things will always get a little bit harder. As a sophisticated general, Jebei predicted that there would be one uprising happening in the country sooner or later which might increase the cost (setting up guarders) on exactly ONE road. Nevertheless he did not know which road would be affected, but only got the information of some suspicious road cost changes. We assumed that the probability of each suspicious case was the same. Since that after the uprising happened, the plan of guarder setting should be rearranged to achieve the minimal cost, Jebei Noyan wanted to know the new expected minimal total cost immediately based on current information.

Input
There are no more than 20 test cases in the input.
For each test case, the first line contains two integers N and M (1<=N<=3000, 0<=M<=N×N), demonstrating the number of cities and roads in Pushtuar. Cities are numbered from 0 to N-1. In the each of the following M lines, there are three integers xi, yi and ci(ci<=107), showing that there is a bidirectional road between xi and yi, while the cost of setting up guarders on this road is ci. We guarantee that the graph is connected. The total cost of the graph is less or equal to 109.

The next line contains an integer Q (1<=Q<=10000) representing the number of suspicious road cost changes. In the following Q lines, each line contains three integers Xi, Yi and Ci showing that the cost of road (Xi, Yi) may change to Ci (Ci<=107). We guarantee that the road always exists and Ci is larger than the original cost (we guarantee that there is at most one road connecting two cities directly). Please note that the probability of each suspicious road cost change is the same.

Output
For each test case, output a real number demonstrating the expected minimal total cost. The result should be rounded to 4 digits after decimal point.

Sample Input

3 3
0 1 3
0 2 2
1 2 5
3
0 2 3
1 2 6
0 1 6
0 0

Sample Output

6.0000

Hint

The initial minimal cost is 5 by connecting city 0 to 1 and city 0 to 2. In the first suspicious case, the minimal total cost is increased to 6;
 the second case remains 5; the third case is increased to 7. As the result, the expected cost is (5+6+7)/3 = 6.

题目大意:给出一些边,然后我们可以增大一条边的权值,然后对于每个增加边的权值之后,我们得到的最小生成树的和,然后得到所有询问边权的平均值。
解题思路:修改一条边之后,如果这条边不是原图中的最小生成树中的边,那么不会改变原最小生成树的权值和,如果这条边是原图中的最小生成树的边,那么我们就先删掉这条边,然后可以得到两个连通分量,然后再加上可以连通着这两个连通分量的最小边,那么我们要怎么去求得这个最小边呢?我们可以使用树形DP的方法去求得每个点与其他点的除了最小生成树的最小边。
我们可以使用dp[i][j]记录i点到j点的最小距离,我们先考虑一个点root,我们假设该点位于是一个子树的根,然后我们遍历另一个子树的根,然后我们先求出点v的子树vv结点到root的最大距离,那么此时点root到v的最大距离就等于dis[root][v]和dp[root][vv]的最大值。我们遍历点root,遍历完之后就可以得到所有的dp信息啦。
代码:

#include <bits/stdc++.h>
using namespace std;
const int maxn=3100;
const int inf=0x3f3f3f3f;
struct node {
   int u,v,w;
   bool operator <(node a)const {
       return w<a.w;
   }
} e[maxn*maxn];
struct edge {
   int v,next;
} t[maxn];
int head[maxn],cnt;
void add(int a,int b) {
   t[++cnt]=edge{b,head[a]};
   head[a]=cnt;
}
int mst,n,m,fa[maxn],dis[maxn][maxn],use[maxn][maxn],dp[maxn][maxn];
int findfa(int x) {
   return fa[x]=(fa[x]==x?x:findfa(fa[x]));
}
void eurl() {
   sort(e+1,e+m+1);
   mst=0;
   int tot=0;
   for(int i=1; i<=m; i++) {
       int u=e[i].u,v=e[i].v,w=e[i].w;
       int tx=findfa(u),ty=findfa(v);
       if(tx!=ty) {
           fa[tx]=ty;
           mst+=w;
           tot++;use[u][v]=use[v][u]=1;
           add(u,v);
           add(v,u);
       }
       if(tot>=n-1)
           return ;
   }
}
int dfs(int root,int u,int f)
{
   int minn=inf;
   for(int i=head[u];i;i=t[i].next){
       int v=t[i].v;
       if(v==f)continue;
       int tmp=dfs(root,v,u);
       minn=min(tmp,minn);
       dp[u][v]=dp[v][u]=min(dp[u][v],tmp);
   }
   if(f!=root) minn=min(minn,dis[u][root]);
   return minn;
}
int main() {
   while(~scanf("%d%d",&n,&m)&&n&&m) {
       memset(dis,inf,sizeof dis);
       for(int i=1; i<=n; i++) {
           fa[i]=i;
           head[i]=0;
           dis[i][i]=0;
       }
       cnt=0;
       memset(head,0,sizeof head);
       memset(dp,inf,sizeof dp);
       memset(use,0,sizeof use);
       for(int i=1;i<=m;i++){
           int x,y,w;
           scanf("%d%d%d",&x,&y,&w);
           x++,y++;
           e[i]=node{x,y,w};
           dis[x][y]=dis[y][x]=w;
       }
       eurl();
       for(int i=1;i<=n;i++)dfs(i,i,i);
       int q;
       scanf("%d",&q);
       int l=q;
       double ans=0;
       while(l--){
           int x,y,w;
           scanf("%d%d%d",&x,&y,&w);
           x++,y++;
           if(use[x][y]) ans+=mst-dis[x][y]+min(dp[x][y],w);
           else ans+=mst;
       }
       printf("%.4f\n",ans/q);
   }
   return 0;
}
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值